namespace PkmnLib.Plugin.Gen7.Scripts.Pokemon;

[Script(ScriptCategory.Pokemon, "throat_chop")]
public class ThroatChopEffect : Script, IScriptPreventMoveSelection, IScriptFailMove, IScriptOnEndTurn
{
    private int _turns = 3;

    /// <inheritdoc />
    public void PreventMoveSelection(IMoveChoice choice, ref bool prevent)
    {
        if (choice.ChosenMove.MoveData.HasFlag(MoveFlags.Sound))
            prevent = true;
    }

    /// <inheritdoc />
    public void FailMove(IExecutingMove move, ref bool fail)
    {
        if (move.UseMove.HasFlag(MoveFlags.Sound))
            fail = true;
    }

    /// <inheritdoc />
    public void OnEndTurn(IScriptSource owner, IBattle battle)
    {
        _turns--;
        if (_turns <= 0)
            RemoveSelf();
    }
}